]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
test: Set all times to UTC
[notmuch] / test / test-lib.sh
1 #!/bin/bash
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22         # do not redirect again
23         ;;
24 *' --tee '*|*' --va'*)
25         mkdir -p test-results
26         BASE=test-results/$(basename "$0" .sh)
27         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28          echo $? > $BASE.exit) | tee $BASE.out
29         test "$(cat $BASE.exit)" = 0
30         exit
31         ;;
32 esac
33
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
36
37 # For repeatability, reset the environment to known value.
38 LANG=C
39 LC_ALL=C
40 PAGER=cat
41 TZ=UTC
42 TERM=dumb
43 export LANG LC_ALL PAGER TERM TZ
44 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
45
46 # Protect ourselves from common misconfiguration to export
47 # CDPATH into the environment
48 unset CDPATH
49
50 unset GREP_OPTIONS
51
52 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
53         1|2|true)
54                 echo "* warning: Some tests will not work if GIT_TRACE" \
55                         "is set as to trace on STDERR ! *"
56                 echo "* warning: Please set GIT_TRACE to something" \
57                         "other than 1, 2 or true ! *"
58                 ;;
59 esac
60
61 # Convenience
62 #
63 # A regexp to match 5 and 40 hexdigits
64 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
65 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
66
67 _x04='[0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
68 _x32="$_x04$_x04$_x04$_x04$_x04$_x04$_x04$_x04"
69
70 # Each test should start with something like this, after copyright notices:
71 #
72 # test_description='Description of this test...
73 # This test checks if command xyzzy does the right thing...
74 # '
75 # . ./test-lib.sh
76 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
77                 TERM=$ORIGINAL_TERM &&
78                 export TERM &&
79                 [ -t 1 ] &&
80                 tput bold >/dev/null 2>&1 &&
81                 tput setaf 1 >/dev/null 2>&1 &&
82                 tput sgr0 >/dev/null 2>&1
83         ) &&
84         color=t
85
86 while test "$#" -ne 0
87 do
88         case "$1" in
89         -d|--d|--de|--deb|--debu|--debug)
90                 debug=t; shift ;;
91         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
92                 immediate=t; shift ;;
93         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
94                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
95         -h|--h|--he|--hel|--help)
96                 help=t; shift ;;
97         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
98                 verbose=t; shift ;;
99         -q|--q|--qu|--qui|--quie|--quiet)
100                 quiet=t; shift ;;
101         --with-dashes)
102                 with_dashes=t; shift ;;
103         --no-color)
104                 color=; shift ;;
105         --no-python)
106                 # noop now...
107                 shift ;;
108         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
109                 valgrind=t; verbose=t; shift ;;
110         --tee)
111                 shift ;; # was handled already
112         --root=*)
113                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
114                 shift ;;
115         *)
116                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
117         esac
118 done
119
120 if test -n "$color"; then
121         say_color () {
122                 (
123                 TERM=$ORIGINAL_TERM
124                 export TERM
125                 case "$1" in
126                         error) tput bold; tput setaf 1;; # bold red
127                         skip)  tput bold; tput setaf 2;; # bold green
128                         pass)  tput setaf 2;;            # green
129                         info)  tput setaf 3;;            # brown
130                         *) test -n "$quiet" && return;;
131                 esac
132                 shift
133                 printf "* %s" "$*"
134                 tput sgr0
135                 echo
136                 )
137         }
138 else
139         say_color() {
140                 test -z "$1" && test -n "$quiet" && return
141                 shift
142                 echo "* $*"
143         }
144 fi
145
146 error () {
147         say_color error "error: $*"
148         GIT_EXIT_OK=t
149         exit 1
150 }
151
152 say () {
153         say_color info "$*"
154 }
155
156 test "${test_description}" != "" ||
157 error "Test script did not set test_description."
158
159 if test "$help" = "t"
160 then
161         echo "$test_description"
162         exit 0
163 fi
164
165 exec 5>&1
166 if test "$verbose" = "t"
167 then
168         exec 4>&2 3>&1
169 else
170         exec 4>/dev/null 3>/dev/null
171 fi
172
173 test_failure=0
174 test_count=0
175 test_fixed=0
176 test_broken=0
177 test_success=0
178
179 die () {
180         code=$?
181         if test -n "$GIT_EXIT_OK"
182         then
183                 exit $code
184         else
185                 echo >&5 "FATAL: Unexpected exit with code $code"
186                 exit 1
187         fi
188 }
189
190 GIT_EXIT_OK=
191 trap 'die' EXIT
192
193 test_decode_color () {
194         sed     -e 's/.\[1m/<WHITE>/g' \
195                 -e 's/.\[31m/<RED>/g' \
196                 -e 's/.\[32m/<GREEN>/g' \
197                 -e 's/.\[33m/<YELLOW>/g' \
198                 -e 's/.\[34m/<BLUE>/g' \
199                 -e 's/.\[35m/<MAGENTA>/g' \
200                 -e 's/.\[36m/<CYAN>/g' \
201                 -e 's/.\[m/<RESET>/g'
202 }
203
204 q_to_nul () {
205         perl -pe 'y/Q/\000/'
206 }
207
208 q_to_cr () {
209         tr Q '\015'
210 }
211
212 append_cr () {
213         sed -e 's/$/Q/' | tr Q '\015'
214 }
215
216 remove_cr () {
217         tr '\015' Q | sed -e 's/Q$//'
218 }
219
220 # Notmuch helper functions
221 increment_mtime_amount=0
222 increment_mtime ()
223 {
224     dir="$1"
225
226     increment_mtime_amount=$((increment_mtime_amount + 1))
227     touch -d "+${increment_mtime_amount} seconds" "$dir"
228 }
229
230 # Generate a new message in the mail directory, with a unique message
231 # ID and subject. The message is not added to the index.
232 #
233 # After this function returns, the filename of the generated message
234 # is available as $gen_msg_filename and the message ID is available as
235 # $gen_msg_id .
236 #
237 # This function supports named parameters with the bash syntax for
238 # assigning a value to an associative array ([name]=value). The
239 # supported parameters are:
240 #
241 #  [dir]=directory/of/choice
242 #
243 #       Generate the message in directory 'directory/of/choice' within
244 #       the mail store. The directory will be created if necessary.
245 #
246 #  [body]=text
247 #
248 #       Text to use as the body of the email message
249 #
250 #  '[from]="Some User <user@example.com>"'
251 #  '[to]="Some User <user@example.com>"'
252 #  '[subject]="Subject of email message"'
253 #  '[date]="RFC 822 Date"'
254 #
255 #       Values for email headers. If not provided, default values will
256 #       be generated instead.
257 #
258 #  '[cc]="Some User <user@example.com>"'
259 #  [reply-to]=some-address
260 #  [in-reply-to]=<message-id>
261 #  [references]=<message-id>
262 #  [content-type]=content-type-specification
263 #  '[header]=full header line, including keyword'
264 #
265 #       Additional values for email headers. If these are not provided
266 #       then the relevant headers will simply not appear in the
267 #       message.
268 #
269 #  '[id]=message-id'
270 #
271 #       Controls the message-id of the created message.
272 gen_msg_cnt=0
273 gen_msg_filename=""
274 gen_msg_id=""
275 generate_message ()
276 {
277     # This is our (bash-specific) magic for doing named parameters
278     local -A template="($@)"
279     local additional_headers
280
281     gen_msg_cnt=$((gen_msg_cnt + 1))
282     gen_msg_name=msg-$(printf "%03d" $gen_msg_cnt)
283
284     if [ -z "${template[id]}" ]; then
285         gen_msg_id="${gen_msg_name}@notmuch-test-suite"
286     else
287         gen_msg_id="${template[id]}"
288     fi
289
290     if [ -z "${template[dir]}" ]; then
291         gen_msg_filename="${MAIL_DIR}/$gen_msg_name"
292     else
293         gen_msg_filename="${MAIL_DIR}/${template[dir]}/$gen_msg_name"
294         mkdir -p "$(dirname "$gen_msg_filename")"
295     fi
296
297     if [ -z "${template[body]}" ]; then
298         template[body]="This is just a test message (#${gen_msg_cnt})"
299     fi
300
301     if [ -z "${template[from]}" ]; then
302         template[from]="Notmuch Test Suite <test_suite@notmuchmail.org>"
303     fi
304
305     if [ -z "${template[to]}" ]; then
306         template[to]="Notmuch Test Suite <test_suite@notmuchmail.org>"
307     fi
308
309     if [ -z "${template[subject]}" ]; then
310         template[subject]="Test message #${gen_msg_cnt}"
311     fi
312
313     if [ -z "${template[date]}" ]; then
314         template[date]="Tue, 05 Jan 2001 15:43:57 -0000"
315     fi
316
317     additional_headers=""
318     if [ ! -z "${template[header]}" ]; then
319         additional_headers="${template[header]}
320 ${additional_headers}"
321     fi
322
323     if [ ! -z "${template[reply-to]}" ]; then
324         additional_headers="Reply-To: ${template[reply-to]}
325 ${additional_headers}"
326     fi
327
328     if [ ! -z "${template[in-reply-to]}" ]; then
329         additional_headers="In-Reply-To: ${template[in-reply-to]}
330 ${additional_headers}"
331     fi
332
333     if [ ! -z "${template[cc]}" ]; then
334         additional_headers="Cc: ${template[cc]}
335 ${additional_headers}"
336     fi
337
338     if [ ! -z "${template[references]}" ]; then
339         additional_headers="References: ${template[references]}
340 ${additional_headers}"
341     fi
342
343     if [ ! -z "${template[content-type]}" ]; then
344         additional_headers="Content-Type: ${template[content-type]}
345 ${additional_headers}"
346     fi
347
348
349 cat <<EOF >"$gen_msg_filename"
350 From: ${template[from]}
351 To: ${template[to]}
352 Message-Id: <${gen_msg_id}>
353 Subject: ${template[subject]}
354 Date: ${template[date]}
355 ${additional_headers}
356 ${template[body]}
357 EOF
358
359     # Ensure that the mtime of the containing directory is updated
360     increment_mtime "$(dirname "${gen_msg_filename}")"
361 }
362
363 # Generate a new message and add it to the index.
364 #
365 # All of the arguments and return values supported by generate_message
366 # are also supported here, so see that function for details.
367 add_message ()
368 {
369     generate_message "$@" &&
370     notmuch new > /dev/null
371 }
372
373 pass_if_equal ()
374 {
375     output=$1
376     expected=$2
377
378     if [ "$output" = "$expected" ]; then
379         true
380     else
381         testname=$this_test.$test_count
382         echo "$expected" > $testname.expected
383         echo "$output" > $testname.output
384         diff -u $testname.expected $testname.output
385         false
386     fi
387 }
388
389 TEST_DIR=$(pwd)/test.$$
390 MAIL_DIR=${TEST_DIR}/mail
391 export NOTMUCH_CONFIG=${TEST_DIR}/notmuch-config
392 NOTMUCH=notmuch
393
394 NOTMUCH_NEW ()
395 {
396     notmuch new | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
397 }
398
399 notmuch_search_sanitize ()
400 {
401     sed -r -e 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
402 }
403
404 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
405 notmuch_show_sanitize ()
406 {
407     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
408 }
409
410 # End of notmuch helper functions
411
412 # Use test_set_prereq to tell that a particular prerequisite is available.
413 # The prerequisite can later be checked for in two ways:
414 #
415 # - Explicitly using test_have_prereq.
416 #
417 # - Implicitly by specifying the prerequisite tag in the calls to
418 #   test_expect_{success,failure,code}.
419 #
420 # The single parameter is the prerequisite tag (a simple word, in all
421 # capital letters by convention).
422
423 test_set_prereq () {
424         satisfied="$satisfied$1 "
425 }
426 satisfied=" "
427
428 test_have_prereq () {
429         case $satisfied in
430         *" $1 "*)
431                 : yes, have it ;;
432         *)
433                 ! : nope ;;
434         esac
435 }
436
437 # You are not expected to call test_ok_ and test_failure_ directly, use
438 # the text_expect_* functions instead.
439
440 test_ok_ () {
441         test_success=$(($test_success + 1))
442         say_color "" "  ok $test_count: $@"
443 }
444
445 test_failure_ () {
446         test_failure=$(($test_failure + 1))
447         say_color error "FAIL $test_count: $1"
448         shift
449         echo "$@" | sed -e 's/^/        /'
450         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
451 }
452
453 test_known_broken_ok_ () {
454         test_fixed=$(($test_fixed+1))
455         say_color "" "  FIXED $test_count: $@"
456 }
457
458 test_known_broken_failure_ () {
459         test_broken=$(($test_broken+1))
460         say_color skip "  still broken $test_count: $@"
461 }
462
463 test_debug () {
464         test "$debug" = "" || eval "$1"
465 }
466
467 test_run_ () {
468         test_cleanup=:
469         eval >&3 2>&4 "$1"
470         eval_ret=$?
471         eval >&3 2>&4 "$test_cleanup"
472         return 0
473 }
474
475 test_skip () {
476         test_count=$(($test_count+1))
477         to_skip=
478         for skp in $GIT_SKIP_TESTS
479         do
480                 case $this_test.$test_count in
481                 $skp)
482                         to_skip=t
483                 esac
484         done
485         if test -z "$to_skip" && test -n "$prereq" &&
486            ! test_have_prereq "$prereq"
487         then
488                 to_skip=t
489         fi
490         case "$to_skip" in
491         t)
492                 say_color skip >&3 "skipping test: $@"
493                 say_color skip "skip $test_count: $1"
494                 : true
495                 ;;
496         *)
497                 false
498                 ;;
499         esac
500 }
501
502 test_expect_failure () {
503         test "$#" = 3 && { prereq=$1; shift; } || prereq=
504         test "$#" = 2 ||
505         error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
506         if ! test_skip "$@"
507         then
508                 say >&3 "checking known breakage: $2"
509                 test_run_ "$2"
510                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
511                 then
512                         test_known_broken_ok_ "$1"
513                 else
514                         test_known_broken_failure_ "$1"
515                 fi
516         fi
517         echo >&3 ""
518 }
519
520 test_expect_success () {
521         test "$#" = 3 && { prereq=$1; shift; } || prereq=
522         test "$#" = 2 ||
523         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
524         if ! test_skip "$@"
525         then
526                 say >&3 "expecting success: $2"
527                 test_run_ "$2"
528                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
529                 then
530                         test_ok_ "$1"
531                 else
532                         test_failure_ "$@"
533                 fi
534         fi
535         echo >&3 ""
536 }
537
538 test_expect_code () {
539         test "$#" = 4 && { prereq=$1; shift; } || prereq=
540         test "$#" = 3 ||
541         error "bug in the test script: not 3 or 4 parameters to test-expect-code"
542         if ! test_skip "$@"
543         then
544                 say >&3 "expecting exit code $1: $3"
545                 test_run_ "$3"
546                 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
547                 then
548                         test_ok_ "$2"
549                 else
550                         test_failure_ "$@"
551                 fi
552         fi
553         echo >&3 ""
554 }
555
556 # test_external runs external test scripts that provide continuous
557 # test output about their progress, and succeeds/fails on
558 # zero/non-zero exit code.  It outputs the test output on stdout even
559 # in non-verbose mode, and announces the external script with "* run
560 # <n>: ..." before running it.  When providing relative paths, keep in
561 # mind that all scripts run in "trash directory".
562 # Usage: test_external description command arguments...
563 # Example: test_external 'Perl API' perl ../path/to/test.pl
564 test_external () {
565         test "$#" = 4 && { prereq=$1; shift; } || prereq=
566         test "$#" = 3 ||
567         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
568         descr="$1"
569         shift
570         if ! test_skip "$descr" "$@"
571         then
572                 # Announce the script to reduce confusion about the
573                 # test output that follows.
574                 say_color "" " run $test_count: $descr ($*)"
575                 # Run command; redirect its stderr to &4 as in
576                 # test_run_, but keep its stdout on our stdout even in
577                 # non-verbose mode.
578                 "$@" 2>&4
579                 if [ "$?" = 0 ]
580                 then
581                         test_ok_ "$descr"
582                 else
583                         test_failure_ "$descr" "$@"
584                 fi
585         fi
586 }
587
588 # Like test_external, but in addition tests that the command generated
589 # no output on stderr.
590 test_external_without_stderr () {
591         # The temporary file has no (and must have no) security
592         # implications.
593         tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
594         stderr="$tmp/git-external-stderr.$$.tmp"
595         test_external "$@" 4> "$stderr"
596         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
597         descr="no stderr: $1"
598         shift
599         say >&3 "expecting no stderr from previous command"
600         if [ ! -s "$stderr" ]; then
601                 rm "$stderr"
602                 test_ok_ "$descr"
603         else
604                 if [ "$verbose" = t ]; then
605                         output=`echo; echo Stderr is:; cat "$stderr"`
606                 else
607                         output=
608                 fi
609                 # rm first in case test_failure exits.
610                 rm "$stderr"
611                 test_failure_ "$descr" "$@" "$output"
612         fi
613 }
614
615 # This is not among top-level (test_expect_success | test_expect_failure)
616 # but is a prefix that can be used in the test script, like:
617 #
618 #       test_expect_success 'complain and die' '
619 #           do something &&
620 #           do something else &&
621 #           test_must_fail git checkout ../outerspace
622 #       '
623 #
624 # Writing this as "! git checkout ../outerspace" is wrong, because
625 # the failure could be due to a segv.  We want a controlled failure.
626
627 test_must_fail () {
628         "$@"
629         test $? -gt 0 -a $? -le 129 -o $? -gt 192
630 }
631
632 # test_cmp is a helper function to compare actual and expected output.
633 # You can use it like:
634 #
635 #       test_expect_success 'foo works' '
636 #               echo expected >expected &&
637 #               foo >actual &&
638 #               test_cmp expected actual
639 #       '
640 #
641 # This could be written as either "cmp" or "diff -u", but:
642 # - cmp's output is not nearly as easy to read as diff -u
643 # - not all diff versions understand "-u"
644
645 test_cmp() {
646         $GIT_TEST_CMP "$@"
647 }
648
649 # This function can be used to schedule some commands to be run
650 # unconditionally at the end of the test to restore sanity:
651 #
652 #       test_expect_success 'test core.capslock' '
653 #               git config core.capslock true &&
654 #               test_when_finished "git config --unset core.capslock" &&
655 #               hello world
656 #       '
657 #
658 # That would be roughly equivalent to
659 #
660 #       test_expect_success 'test core.capslock' '
661 #               git config core.capslock true &&
662 #               hello world
663 #               git config --unset core.capslock
664 #       '
665 #
666 # except that the greeting and config --unset must both succeed for
667 # the test to pass.
668
669 test_when_finished () {
670         test_cleanup="{ $*
671                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
672 }
673
674 test_done () {
675         GIT_EXIT_OK=t
676         test_results_dir="$TEST_DIRECTORY/test-results"
677         mkdir -p "$test_results_dir"
678         test_results_path="$test_results_dir/${0%.sh}-$$"
679
680         echo "total $test_count" >> $test_results_path
681         echo "success $test_success" >> $test_results_path
682         echo "fixed $test_fixed" >> $test_results_path
683         echo "broken $test_broken" >> $test_results_path
684         echo "failed $test_failure" >> $test_results_path
685         echo "" >> $test_results_path
686
687         if test "$test_fixed" != 0
688         then
689                 say_color pass "fixed $test_fixed known breakage(s)"
690         fi
691         if test "$test_broken" != 0
692         then
693                 say_color error "still have $test_broken known breakage(s)"
694                 msg="remaining $(($test_count-$test_broken)) test(s)"
695         else
696                 msg="$test_count test(s)"
697         fi
698         case "$test_failure" in
699         0)
700                 say_color pass "passed all $msg"
701
702                 test -d "$remove_trash" &&
703                 cd "$(dirname "$remove_trash")" &&
704                 rm -rf "$(basename "$remove_trash")"
705
706                 exit 0 ;;
707
708         *)
709                 say_color error "failed $test_failure among $msg"
710                 exit 1 ;;
711
712         esac
713 }
714
715 find_notmuch_path ()
716 {
717     dir="$1"
718
719     while [ -n "$dir" ]; do
720         bin="$dir/notmuch"
721         if [ -x "$bin" ]; then
722             echo "$dir"
723             return
724         fi
725         dir="$(dirname "$dir")"
726         if [ "$dir" = "/" ]; then
727             break
728         fi
729     done
730 }
731
732 # Test the binaries we have just built.  The tests are kept in
733 # test/ subdirectory and are run in 'trash directory' subdirectory.
734 TEST_DIRECTORY=$(pwd)
735 # FIXME: Only the normal case bellow is updated to notmuch
736 if test -n "$valgrind"
737 then
738         make_symlink () {
739                 test -h "$2" &&
740                 test "$1" = "$(readlink "$2")" || {
741                         # be super paranoid
742                         if mkdir "$2".lock
743                         then
744                                 rm -f "$2" &&
745                                 ln -s "$1" "$2" &&
746                                 rm -r "$2".lock
747                         else
748                                 while test -d "$2".lock
749                                 do
750                                         say "Waiting for lock on $2."
751                                         sleep 1
752                                 done
753                         fi
754                 }
755         }
756
757         make_valgrind_symlink () {
758                 # handle only executables
759                 test -x "$1" || return
760
761                 base=$(basename "$1")
762                 symlink_target=$TEST_DIRECTORY/../$base
763                 # do not override scripts
764                 if test -x "$symlink_target" &&
765                     test ! -d "$symlink_target" &&
766                     test "#!" != "$(head -c 2 < "$symlink_target")"
767                 then
768                         symlink_target=../valgrind.sh
769                 fi
770                 case "$base" in
771                 *.sh|*.perl)
772                         symlink_target=../unprocessed-script
773                 esac
774                 # create the link, or replace it if it is out of date
775                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
776         }
777
778         # override all git executables in TEST_DIRECTORY/..
779         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
780         mkdir -p "$GIT_VALGRIND"/bin
781         for file in $TEST_DIRECTORY/../git* $TEST_DIRECTORY/../test-*
782         do
783                 make_valgrind_symlink $file
784         done
785         OLDIFS=$IFS
786         IFS=:
787         for path in $PATH
788         do
789                 ls "$path"/git-* 2> /dev/null |
790                 while read file
791                 do
792                         make_valgrind_symlink "$file"
793                 done
794         done
795         IFS=$OLDIFS
796         PATH=$GIT_VALGRIND/bin:$PATH
797         GIT_EXEC_PATH=$GIT_VALGRIND/bin
798         export GIT_VALGRIND
799 elif test -n "$GIT_TEST_INSTALLED" ; then
800         GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
801         error "Cannot run git from $GIT_TEST_INSTALLED."
802         PATH=$GIT_TEST_INSTALLED:$TEST_DIRECTORY/..:$PATH
803         GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
804 else # normal case
805         notmuch_path=`find_notmuch_path "$TEST_DIRECTORY"`
806         test -n "$notmuch_path" && PATH="$notmuch_path:$PATH"
807 fi
808 export PATH
809
810 # Test repository
811 test="trash directory.$(basename "$0" .sh)"
812 test -n "$root" && test="$root/$test"
813 case "$test" in
814 /*) TRASH_DIRECTORY="$test" ;;
815  *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
816 esac
817 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
818 rm -fr "$test" || {
819         GIT_EXIT_OK=t
820         echo >&5 "FATAL: Cannot prepare test area"
821         exit 1
822 }
823
824 MAIL_DIR="${TRASH_DIRECTORY}/mail"
825 export NOTMUCH_CONFIG="${TRASH_DIRECTORY}/notmuch-config"
826
827 mkdir -p "${test}"
828 mkdir "$MAIL_DIR"
829
830 cat <<EOF >"${NOTMUCH_CONFIG}"
831 [database]
832 path=${MAIL_DIR}
833
834 [user]
835 name=Notmuch Test Suite
836 primary_email=test_suite@notmuchmail.org
837 other_email=test_suite_other@notmuchmail.org;test_suite@otherdomain.org
838 EOF
839
840
841 # Use -P to resolve symlinks in our working directory so that the cwd
842 # in subprocesses like git equals our $PWD (for pathname comparisons).
843 cd -P "$test" || error "Cannot setup test environment"
844
845 this_test=${0##*/}
846 this_test=${this_test%%-*}
847 for skp in $GIT_SKIP_TESTS
848 do
849         to_skip=
850         for skp in $GIT_SKIP_TESTS
851         do
852                 case "$this_test" in
853                 $skp)
854                         to_skip=t
855                 esac
856         done
857         case "$to_skip" in
858         t)
859                 say_color skip >&3 "skipping test $this_test altogether"
860                 say_color skip "skip all tests in $this_test"
861                 test_done
862         esac
863 done
864
865 # Provide an implementation of the 'yes' utility
866 yes () {
867         if test $# = 0
868         then
869                 y=y
870         else
871                 y="$*"
872         fi
873
874         while echo "$y"
875         do
876                 :
877         done
878 }
879
880 # Fix some commands on Windows
881 case $(uname -s) in
882 *MINGW*)
883         # Windows has its own (incompatible) sort and find
884         sort () {
885                 /usr/bin/sort "$@"
886         }
887         find () {
888                 /usr/bin/find "$@"
889         }
890         sum () {
891                 md5sum "$@"
892         }
893         # git sees Windows-style pwd
894         pwd () {
895                 builtin pwd -W
896         }
897         # no POSIX permissions
898         # backslashes in pathspec are converted to '/'
899         # exec does not inherit the PID
900         ;;
901 *)
902         test_set_prereq POSIXPERM
903         test_set_prereq BSLASHPSPEC
904         test_set_prereq EXECKEEPSPID
905         ;;
906 esac
907
908 test -z "$NO_PERL" && test_set_prereq PERL
909 test -z "$NO_PYTHON" && test_set_prereq PYTHON
910
911 # test whether the filesystem supports symbolic links
912 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
913 rm -f y